/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://ayyi.org               |
* | copyright (C) 2004-2016 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#include <model/common.h>
#include <glib-object.h>
#include <model/am_palette.h>
#include <model/am_controller.h>

#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _ClientControllerPrivate {
	gint _property1;
};

static gpointer client_controller_parent_class = NULL;

#define CLIENT_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CLIENT_CONTROLLER, ClientControllerPrivate))

enum  {
	CLIENT_CONTROLLER_DUMMY_PROPERTY,
	CLIENT_CONTROLLER_PROPERTY1
};

static void g_cclosure_user_marshal_VOID__INT_INT_INT          (GClosure*, GValue*, guint, const GValue*, gpointer, gpointer);
static void g_cclosure_user_marshal_VOID__POINTER_UINT_POINTER (GClosure*, GValue*, guint, const GValue*, gpointer, gpointer);
static void g_cclosure_user_marshal_VOID__POINTER_POINTER      (GClosure*, GValue*, guint, const GValue*, gpointer, gpointer);
static void client_controller_finalize                         (GObject*);
static void _vala_client_controller_get_property               (GObject*, guint, GValue*, GParamSpec*);


ClientController*
client_controller_construct (GType object_type)
{
	ClientController* self = (ClientController*) g_object_new (object_type, NULL);
	g_signal_emit_by_name (self, "palette-change");
	return self;
}


ClientController*
client_controller_new ()
{
	return client_controller_construct (TYPE_CLIENT_CONTROLLER);
}


gint
client_controller_get_property1 (ClientController* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_property1;
	return result;
}


static void
g_cclosure_user_marshal_VOID__INT_INT_INT (GClosure* closure, GValue* return_value, guint n_param_values, const GValue* param_values, gpointer invocation_hint, gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
}


static void
g_cclosure_user_marshal_VOID__POINTER_UINT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_UINT_POINTER) (gpointer data1, gpointer arg_1, guint arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_UINT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__POINTER_UINT_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_pointer (param_values + 3), data2);
}


static void
g_cclosure_user_marshal_VOID__POINTER_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__POINTER_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), data2);
}


static void
client_controller_class_init (ClientControllerClass * klass)
{
	client_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ClientControllerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_client_controller_get_property;
	G_OBJECT_CLASS (klass)->finalize = client_controller_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIENT_CONTROLLER_PROPERTY1, g_param_spec_int ("property1", "property1", "property1", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));

	g_signal_new ("periodic_update", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("song_load", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("song_unload", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("song_length_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("tempo_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("locators_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("progress", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	g_signal_new ("transport_sync", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_stop", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_play", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_rew", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_ff", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_cycle", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("transport_rec", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("pool_item_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	g_signal_new ("tracks_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
	g_signal_new ("tracks_change_by_list", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_UINT_POINTER, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_UINT, G_TYPE_POINTER);
	g_signal_new ("region_delete", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_signal_new ("note_selection_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_POINTER, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_POINTER);
	g_signal_new ("plugin_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	g_signal_new ("curve_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	g_signal_new ("palette_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("songmap_change", TYPE_CLIENT_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
client_controller_instance_init (ClientController* self)
{
	self->priv = CLIENT_CONTROLLER_GET_PRIVATE (self);
	self->priv->_property1 = 1;
}


static void
client_controller_finalize (GObject* obj)
{
	ClientController* self = CLIENT_CONTROLLER (obj);
	_g_list_free0 (self->input_list);
	_g_list_free0 (self->bus_list);
	_g_list_free0 (self->plugins);
	_g_list_free0 (self->work_queue);
	G_OBJECT_CLASS (client_controller_parent_class)->finalize (obj);
}


GType
client_controller_get_type (void)
{
	static volatile gsize client_controller_type_id__volatile = 0;
	if (g_once_init_enter (&client_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClientControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) client_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClientController), 0, (GInstanceInitFunc) client_controller_instance_init, NULL };
		GType client_controller_type_id;
		client_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "ClientController", &g_define_type_info, 0);
		g_once_init_leave (&client_controller_type_id__volatile, client_controller_type_id);
	}
	return client_controller_type_id__volatile;
}


static void
_vala_client_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec)
{
	ClientController* self = CLIENT_CONTROLLER (object);
	switch (property_id) {
		case CLIENT_CONTROLLER_PROPERTY1:
			g_value_set_int (value, client_controller_get_property1 (self));
			break;
		default:
			G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
			break;
	}
}


