/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://ayyi.org               |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __am_controller_h__
#define __am_controller_h__

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <model/am_utils.h>
#include <model/am_palette.h>

G_BEGIN_DECLS

#define TYPE_CLIENT_CONTROLLER (client_controller_get_type ())
#define CLIENT_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLIENT_CONTROLLER, ClientController))
#define CLIENT_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLIENT_CONTROLLER, ClientControllerClass))
#define IS_CLIENT_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLIENT_CONTROLLER))
#define IS_CLIENT_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLIENT_CONTROLLER))
#define CLIENT_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLIENT_CONTROLLER, ClientControllerClass))

typedef struct _ClientController        ClientController;
typedef struct _ClientControllerClass   ClientControllerClass;
typedef struct _ClientControllerPrivate ClientControllerPrivate;

struct _ClientController {
	GObject                  parent_instance;
	ClientControllerPrivate* priv;
	gboolean                 loaded;
	AMObject                 loc[10];
	gboolean                 end_auto;
	gint                     sample_rate;
	gfloat                   beats2bar;
	gchar*                   audiodir;
	gchar*                   peaksdir;
	GtkObject*               tempo_adj;
	QMap                     q_settings[5];
	AMSnapType               snap_mode;

	AMTrackList*             tracks;
	AMList*                  pool;
	AMArray*                 channels;
	AMList*                  parts;
	AMList*                  map_parts;
	GList*                   input_list;
	gchar*                   input_str;
	GList*                   bus_list;
	gchar*                   bus_strs;
	GList*                   plugins;

	uint32_t                 palette[MAX_COLOUR];

	guint                    periodic;
	GList*                   work_queue;
};

struct _ClientControllerClass {
	GObjectClass parent_class;
};

GType             client_controller_get_type      () G_GNUC_CONST;
ClientController* client_controller_new           ();
ClientController* client_controller_construct     (GType);
gint              client_controller_get_property1 (ClientController*);

G_END_DECLS

#endif
