/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __am_palette_h__
#define __am_palette_h__

#define MAX_COLOUR 64
#define ASSERT_PALETTE_NUM(A) if(A < 0 || A >= MAX_COLOUR) return;

void       am_palette_load            (Palette);
void       am_palette_set_style       (Palette, GtkStyle*);
void       am_palette_lookup          (Palette, GdkColor*, int c_idx);
void       am_palette_get_float       (Palette, int c_idx, float* r, float* g, float* b, const unsigned char alpha);
uint32_t   am_palette_get_contrasting (Palette, int c_idx);
gboolean   am_palette_is_dark         (Palette, int c_idx);

void       am_rgba_to_float           (uint32_t rgba, float* r, float* g, float* b);
void       am_rgba_to_gdk             (GdkColor*, uint32_t rgba);
uint32_t   am_gdk_to_rgba             (GdkColor*);
void       colour_get_style_base      (GdkColor*, int state);
void       colour_get_style_bg_       (GdkColor*, int state);
void       colour_get_style_fg        (GdkColor*, int state);
void       colour_get_rgba_str        (char* colorstr, int c_idx, const unsigned char alpha);
void       colour_get_rgb_str         (char* colorstr, int c_idx);

#endif
