/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __am_time_h__
#define __am_time_h__
#include "ayyi/ayyi_time.h"

#define SUBS_PER_BEAT 4           // a gui subbeat is a 16th

#ifdef __am_time_c__
const uint64_t    mu_per_sub  = (AYYI_MU_PER_SUB * AYYI_SUBS_PER_BEAT) / 4;
const uint32_t    ticks_per_beat = 4 * AYYI_TICKS_PER_SUBBEAT;
#endif

int            pos_bar              (GPos*);
int            pos_beat             (GPos*);

void           pos2bbst             (GPos*, char* str);
void           pos2bbst0            (GPos*, char* str);
void           pos2bbs              (GPos*, char* str);
uint64_t       pos2mu               (GPos*);
double         pos2beats            (GPos*);
gboolean       songpos_ayyi2gui     (GPos*, AyyiSongPos*);
AyyiSongPos*   songpos_gui2ayyi     (AyyiSongPos*, GPos*);
gboolean       gpos_is_valid        (GPos*);
gboolean       gpos_is_empty        (GPos*);

gboolean       pos_is_before        (const GPos* pos1, const GPos* pos2);
gboolean       pos_is_after         (const GPos* pos1, const GPos* pos2);

void           mu2pos               (uint64_t len, GPos* pos);
void           samples2pos          (uint64_t samples, GPos*);
unsigned       pos2samples          (GPos*);

void           pos_add              (GPos*, const GPos*);
void           pos_subtract         (GPos*, const GPos*);
void           pos_divide           (GPos*, int);
int            pos_diff             (const GPos* pos1, const GPos* pos2);
gboolean       pos_cmp              (const GPos*, const GPos*);
void           pos_min              (GPos*, const GPos*);
void           pos_max              (GPos*, const GPos*);

long           samples2beats        (uint64_t samples);
double         samples2secs         (uint64_t samples);
uint64_t       bars2mu              (float bars);

gboolean       bbst2pos             (const char* bbst, GPos*);
gboolean       bbss2pos             (const char* bbst, AyyiSongPos*);

gboolean       bbst_increment       (char*);
gboolean       bbst_decrement       (char*);

void           am_q_init            ();
gboolean       q_to_nearest         (GPos*, QMap*);
void           q_to_prev            (GPos*, QMap*);
void           q_to_next            (GPos*, QMap*);
void           q_to_prev_or_current (GPos*, QMap*);
void           q_to_next_or_current (GPos*, QMap*);

void           am_snap_to_next      (GPos*);
GPos*          am_snap              (GPos*);
AyyiSongPos*   am_snap_             (AyyiSongPos*);

#endif //__am_time_h__
