/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://ayyi.org               |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __am_track_peer_h__
#define __am_track_peer_h__

#include <model/am_track.h>
#include "model/am_collection.h"

#define am_tracks                      ((ModelCollection*)song->tracks)
#define am_tracks_selection            (((ModelCollection*)song->tracks)->selection)
#define am_track_iterator_new(F, DATA) filter_iterator_new (0, NULL, NULL, am_tracks, F, DATA)

#if !defined(__am_track_c__) || defined(__am_track__peer_c__)
extern AMTrack** track_pool;
#endif

#if defined ( __am_track_c__) || defined(__track_list_c__)
#define track_pool_get_item(A) (AMTrack*)((char*)track_pool + A * sizeof(AMTrack))
#endif

#ifdef __am_private__
void       am_tracks_init               ();
void       am_tracks_reset              ();
TrackNum  _am_tracks_find_unused        ();
void       am_tracks_rebuild_pointers   ();
#endif

#endif //__am_track_peer_h__
