/*
  copyright (C) 2012 Tim Orford <tim@orford.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#define __wf_private__
#include "global.h"
#include "animator.h"

static GList* items = NULL;
static guint timer = 0;
typedef struct
{
	GSourceFunc function;
	gpointer user_data;
} Item;


void
animator_add(GSourceFunc function, gpointer user_data)
{
	bool on_frame(gpointer user_data)
	{
		GList* l = items;
		for(;l;l=l->next){
			Item* i = l->data;
			bool finished = i->function(i->user_data);
			if(finished == TIMER_STOP){
				items = g_list_remove(items, i);
				g_free(i);
			}
		}
		return items ? TIMER_CONTINUE : TIMER_STOP;
	}

	if(!items){
		timer = g_timeout_add(40, (gpointer)on_frame, NULL);
	}

	Item* i = g_new0(Item, 1);
	i->function = function;
	i->user_data = user_data;
	items = g_list_prepend(items, i);
}

