/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2013-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/

static AGl* agl = NULL;


AGlActor*
ghost_actor(gpointer _)
{
	agl = agl_get_instance();

	void ghost_set_state(AGlActor* actor)
	{
		if(agl->use_shaders){
			agl->shaders.plain->uniform.colour = 0x9999993f;
			agl_use_program((AGlShader*)agl->shaders.plain);
		}
	}

	bool ghost_draw(AGlActor* actor)
	{
		agl_rect(0, 0, agl_actor__width(actor), agl_actor__height(actor));

		return true;
	}

	void ghost_init(AGlActor* actor)
	{
		if(agl->use_shaders) actor->paint = ghost_draw;
	}

	AGlActor* actor = AYYI_NEW(AGlActor,
		.name = "Ghost",
		.init = ghost_init,
		.set_state = ghost_set_state,
		.paint = agl_actor__null_painter,
		.region = {0, 0, 1, 1}
	);

	return (AGlActor*)actor;
}

