/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/

static AGlActor*
spp_actor(GtkWidget* panel)
{
	bool spp_actor__paint(AGlActor* actor)
	{
		Arrange* arrange = actor->root->user_data;

		double spp = arr_gl_get_spp_px(arrange) - arr_gl_get_viewport_left(arrange);

		if(agl->use_shaders){
			agl->shaders.plain->uniform.colour = 0xff00007f;
			agl_use_program((AGlShader*)agl->shaders.plain);
			agl_rect(spp, -CGL->actors[ACTOR_TYPE_MAIN]->scrollable.y1, 1, actor->region.y2);

			// mouse cursor on rulerbar (is not done by rulerbar so as to allow caching)
			CanvasOp* op = arrange->canvas->op;
			if(op->mouse.x > -1){
				agl_rect(op->mouse.x, -CGL->actors[ACTOR_TYPE_MAIN]->scrollable.y1, 1, -agl_actor__height(CGL->actors[ACTOR_TYPE_RULER]));
			}
		}else{
			agl_enable(0/*GL_TEXTURE_2D*/);
			glLineWidth(1);
			glColor3f(1.0, 0.0, 0.0);
			glBegin(GL_LINES);
			glVertex3f(spp, arrange->canvas_scrollwin->allocation.height, 0.0);
			glVertex3f(spp + 0.1, -arrange->canvas->vtab[1], 0.0);
			glEnd();
		}
		return true;
	}

	void arr_gl_spp_size(AGlActor* actor)
	{
		actor->region = (AGliRegion){
			.x1 = 0,
			.y1 = 0,
			.x2 = ((AGlActor*)actor->root)->region.x2,
			.y2 = ((AGlActor*)actor->root)->region.y2,
		};
	}

	AGlActor* actor = AGL_NEW(AGlActor,
#ifdef AGL_DEBUG_ACTOR
		.name = "SPP",
#endif
		.paint = spp_actor__paint,
		.set_size = arr_gl_spp_size
	);
	return actor;
}


#if 0
static AGlActor*
test_actor(GtkWidget* panel)
{
	bool spp_actor__paint(AGlActor* actor)
	{
		if(agl->use_shaders){
			agl->shaders.plain->uniform.colour = 0xff00007f;
			agl_use_program((AGlShader*)agl->shaders.plain);
			agl_rect(0, 0, 100, 100);

		}
	}

	void arr_gl_spp_size(AGlActor* actor)
	{
		actor->region = (AGliRegion){
			.x1 = 0,
			.y1 = 0,
			.x2 = 100,
			.y2 = 100,
		};
	}

	AGlActor* actor = g_new0(AGlActor, 1);
	*actor = (AGlActor){
#ifdef AGL_DEBUG_ACTOR
		.name = "Test",
#endif
		.paint = spp_actor__paint,
		.set_size = arr_gl_spp_size
	};
	return actor;
}
#endif

