/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __g_automation_h__
#define __g_automation_h__

#include <model/am_automation.h>

void  automation_init                 ();
void  automation_uninit               ();
void  automation_ctlpts_init          (Arrange*);
void  automation_track_init           (ArrTrk*);
void  automation_track_draw           (Arrange*, ArrTrk*);
void  automation_track_undraw         (Arrange*, ArrTrk*);
void  automation_curves_undraw        (Arrange*);
void  automation_view_on_size_change  (Arrange*);
void  automation_on_curves_change     (Arrange*);
void  automation_curve_draw           (Arrange* , Curve*);
void  automation_curve_draw_fast      (Arrange*, Curve*);
void  automation_view_on_song_load    ();

void  automation_view_toggle          (Arrange*);
void  automation_show                 (Arrange*);
void  automation_hide                 (Arrange*);

void  automation_point_add            (GtkWidget* not_used, Arrange*);
void  automation_point_remove         (GtkWidget* menu_item, Arrange*);
void  g_automation_view_vol           (ArrTrk*);
bool  g_automation_view_pan           (ArrTrk*);
bool  show_control                    (GtkWidget*, gpointer);

void  arr_k_next_node                 (GtkAccelGroup*, Arrange*);

int   automation_view__get_segment    (Arrange*, BPath*, double mousex, int* seg);
void  automation_view__select_segment (Arrange*, ArrAutoPath*, int seg);

#endif
