/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2013-2017 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __arrange_shader_h__
#define __arrange_shader_h__

#include "waveform/shader.h"

typedef struct {
	AGlShader    shader;
	struct {
		uint32_t colour;
		uint32_t border_colour;
		bool     selected;
		int      frame;
		GLfloat  modelview[16];
		GLfloat  projection[16];
	}            uniform;
} PartShader;

enum {
   PART_SHADER_WIDTH = 0,
   PART_SHADER_HEIGHT,
   PART_SHADER_MAX
};

typedef struct {
	AGlShader      shader;
	struct {
		uint32_t   colourX;
	}              uniform;
	AGlUniformInfo uniforms[1];
} PatternShader;

typedef struct {
	AGlShader      shader;
	struct {
		uint32_t   colour;
	}              uniform;
	AGlUniformInfo uniforms[1];
} DottedShader;

typedef struct {
	AGlShader      shader;
	struct {
		uint32_t   colour;
		uint32_t   bg_colour;
		AGliPt     centre;
		float      radius;
	}              uniform;
	AGlUniformInfo uniforms[1];
} CircleShader;

typedef struct {
	AGlShader      shader;
	struct {
		uint32_t   colour;
		uint32_t   bg_colour;
		AGliPt     centre1;
		AGliPt     centre2;
		float      radius;
	}              uniform;
	AGlUniformInfo uniforms[1];
} ScrollbarShader;

extern PartShader part_shader;
extern PlainShader plain_shader;
extern PatternShader pattern_shader;
extern DottedShader dotted_shader;
extern CircleShader circle_shader;
extern ScrollbarShader h_scrollbar_shader;
extern ScrollbarShader v_scrollbar_shader;

extern AGlUniformInfo uniforms17[];

#endif
