/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2016 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __pool_win_h__
#define __pool_win_h__

#define pool_foreach GList* pwindows = windows__get_by_type(AYYI_TYPE_POOL_WIN); if(pwindows){ for(;pwindows;pwindows=pwindows->next){ AyyiPoolWin* pool_window = (AyyiPoolWin*)pwindows->data;
#define end_pool_foreach } g_list_free(pwindows); }

#include <panels/panel.h>
#include "pool_model.h"

G_BEGIN_DECLS

#define AYYI_TYPE_POOL_WIN            (ayyi_pool_win_get_type ())
#define AYYI_POOL_WIN(obj)            (GTK_CHECK_CAST ((obj), AYYI_TYPE_POOL_WIN, AyyiPoolWin))
#define AYYI_POOL_WIN_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), AYYI_TYPE_POOL_WIN, AyyiPoolWinClass))
#define AYYI_IS_POOL_WIN(obj)         (GTK_CHECK_TYPE ((obj), AYYI_TYPE_POOL_WIN))
#define AYYI_IS_POOL_WIN_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), AYYI_TYPE_POOL_WIN))
#define AYYI_POOL_WIN_GET_CLASS(obj)  (GTK_CHECK_GET_CLASS ((obj), AYYI_TYPE_POOL_WIN, AyyiPoolWinClass))

typedef struct _AyyiPoolWinClass AyyiPoolWinClass;

struct _AyyiPoolWinClass {
	AyyiPanelClass parent_class;
};

struct _AyyiPoolWin
{
  AyyiPanel            panel;
  GtkWidget*           menu;           // treeview popup menu.
  GtkWidget*           filer_scrollwin;
 
  GtkWidget*           treeview;
  GtkTreeSelection*    selection;      // for debugging only atm.
  GtkWidget*           scrollwindow;   // scrollwindow for the pool treeview.
  GtkTreeViewColumn*   col2;           // the column displaying peak overviews.
  GList*               expanded_list;  // rowrefs for rows that are expanded in the tree.

  int                  pixbuf_width;
};

GType                ayyi_pool_win_get_type        ();

void                 pool_win__init                ();

void                 pool_win_pixbuf_cell_update   (PoolWindow*, GtkTreeIter*, PoolItem*, int palette_num);

void                 pool_win_statusbar_print_all  (int n, char*);
void                 pool_win_statusbar_update     (PoolWindow*, GtkTreeIter*, AMPart*, AyyiIdx);

G_END_DECLS
#endif //__pool_win_h__
