/**
* +----------------------------------------------------------------------+
* | This file is part of the Ayyi project. http://www.ayyi.org           |
* | copyright (C) 2004-2016 Tim Orford <tim@orford.org>                  |
* +----------------------------------------------------------------------+
* | This program is free software; you can redistribute it and/or modify |
* | it under the terms of the GNU General Public License version 3       |
* | as published by the Free Software Foundation.                        |
* +----------------------------------------------------------------------+
*
*/
#ifndef __transport_panel_h__
#define __transport_panel_h__

#include <model/am_transport.h>
#include "src/transport.h"
#include <panels/panel.h>

G_BEGIN_DECLS

#define AYYI_TYPE_TRANSPORT_WIN            (ayyi_transport_win_get_type ())
#define AYYI_TRANSPORT_WIN(obj)            (GTK_CHECK_CAST ((obj), AYYI_TYPE_TRANSPORT_WIN, AyyiTransportWin))
#define AYYI_TRANSPORT_WIN_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), AYYI_TYPE_TRANSPORT_WIN, AyyiTransportWinClass))
#define AYYI_IS_TRANSPORT_WIN(obj)         (GTK_CHECK_TYPE ((obj), AYYI_TYPE_TRANSPORT_WIN))
#define AYYI_IS_TRANSPORT_WIN_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), AYYI_TYPE_TRANSPORT_WIN))
#define AYYI_TRANSPORT_WIN_GET_CLASS(obj)  (GTK_CHECK_GET_CLASS ((obj), AYYI_TYPE_TRANSPORT_WIN, AyyiTransportWinClass))

typedef struct _AyyiTransportWinClass AyyiTransportWinClass;

#define TR_SIZE 6       //the number of transport buttons.

#define transport_foreach GList* twindows = windows__get_by_type(AYYI_TYPE_TRANSPORT_WIN); if(twindows){ for(;twindows;twindows=twindows->next){ TransportWin* transport = (TransportWin*)twindows->data;
#define end_transport_foreach } g_list_free(twindows); }

enum{
  TRANSTYLE_PLAIN
};


struct _AyyiTransportWinClass {
	AyyiPanelClass parent_class;
};


struct _AyyiTransportWin
{
	AyyiPanel      panel;

	GtkWidget*     hbox;
	GtkWidget*     button_box;
	GtkWidget*     b[TR_SIZE]; //buttons

	GtkWidget*     spp_entry;  //single line version of spp_view
	GtkWidget*     textfx;     //spp display with image processing.
	GtkWidget*     locators;
	GtkTextBuffer* loc[5];

	GtkAllocation  old_allocation;
	gboolean       button_resize_pending; //panel elements are being resized which will require a button resize.
};


GType      ayyi_transport_win_get_type ();
GtkWidget* transport_new               (AyyiShell*, Size*, GtkOrientation);
void       transport_clear_buttons     ();

G_END_DECLS
#endif //__transport_panel_h__
